<template>
  <div class="container">
    <h1 class="display-4">Registered Users</h1>

    <!-- Dugme za dodavanje menadžera, vidi ga samo administrator -->
    <button type="button" class="custom-btn btn-6" @click="goToAddManager"><span>Add Manager</span></button>

    <!-- Search, Sort, and Filter Controls -->
    <div class="search-filters mb-4">
      <input v-model="search.firstName" placeholder="Search by First Name" @input="filterAndSortUsers" />
      <input v-model="search.lastName" placeholder="Search by Last Name" @input="filterAndSortUsers" />
      <input v-model="search.username" placeholder="Search by Username" @input="filterAndSortUsers" />

      <select v-model="sortCriteria" @change="filterAndSortUsers">
        <option value="firstName">First Name</option>
        <option value="lastName">Last Name</option>
        <option value="username">Username</option>
        <option value="collectedPoints">Collected Points</option>
      </select>
      <select v-model="sortOrder" @change="filterAndSortUsers">
        <option value="asc">Ascending</option>
        <option value="desc">Descending</option>
      </select>

      <select v-model="filterRole" @change="filterAndSortUsers">
        <option value="">All Roles</option>
        <option value="Administrator">Administrator</option>
        <option value="Menadzer">Manager</option>
        <option value="Kupac">Customer</option>
      </select>

      <select v-model="filterCustomerType" @change="filterAndSortUsers">
        <option value="">All Customer Types</option>
        <option value="Bronze">Bronze</option>
        <option value="Silver">Silver</option>
        <option value="Gold">Gold</option>
      </select>
    </div>

    <table class="table">
      <thead>
        <tr>
          <th scope="col">Username</th>
          <th scope="col">First Name</th>
          <th scope="col">Last Name</th>
          <th scope="col">Gender</th>
          <th scope="col">Date Of Birth</th>
          <th scope="col">Role</th>
          <th scope="col">Chocolate Factory</th>
          <th scope="col">Collected Points</th>
          <th scope="col">Customer Type</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="user in users" :key="user.username.username">
          <td>{{ user.username.username }}</td>
          <td>{{ user.username.firstName }}</td>
          <td>{{ user.username.lastName }}</td>
          <td>{{ user.username.gender }}</td>
          <td>{{ user.username.dateOfBirth }}</td>
          <td>{{ user.username.role }}</td>
          <td>{{ user.username.chocolateFactory }}</td>
          <td>{{ user.username.collectedPoints }}</td>
          <td>{{ user.username.customerType }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from 'axios';

export default {
  data() {
    return {
      users: [],
      search: {
        firstName: '',
        lastName: '',
        username: ''
      },
      sortCriteria: 'firstName',
      sortOrder: 'asc',
      filterRole: '',
      filterCustomerType: '',
      isAdmin: false // Dodato za proveru administratorske uloge
    };
  },
  methods: {
    async filterAndSortUsers() {
      try {
        const params = {
          firstName: this.search.firstName || undefined,
          lastName: this.search.lastName || undefined,
          username: this.search.username || undefined,
          role: this.filterRole || undefined,
          customerType: this.filterCustomerType || undefined,
          sortBy: this.sortCriteria,
          sortOrder: this.sortOrder
        };

        const response = await axios.get('http://localhost:3000/users', { params });
        this.users = response.data;
      } catch (error) {
        console.error('Error fetching filtered and sorted users:', error);
      }
    },
    goToAddManager() {
      this.$router.push({ name: 'Register', params: { role: 'Menadzer' } });  // Navigacija na stranicu za dodavanje menadžera
    },
    checkAdminRole() {
      const user = JSON.parse(localStorage.getItem('user'));
      this.isAdmin = user && user.role === 'Administrator';
    }
  },
  async created() {
    this.filterAndSortUsers();
    this.checkAdminRole();  // Provera administratorske uloge pri kreiranju
  }
};
</script>


<style scoped>
.container {
  padding: 20px;
}

.search-filters {
  margin-bottom: 20px;
}

.search-filters input,
.search-filters select {
  margin-right: 10px;
  margin-bottom: 10px;
  padding: 8px;
  border-radius: 4px;
  border: 1px solid #ccc;
  font-size: 1rem;
}

.search-filters input:focus,
.search-filters select:focus {
  outline: none;
  border-color: #ff7f00;
}

.table {
  margin-top: 20px;
}

.table th,
.table td {
  text-align: left;
  padding: 12px;
  vertical-align: middle;
  border-top: 1px solid #dee2e6;
}

.table tbody tr:hover td {
  background-color: #f1c16a !important;
  transition: background-color 1.0s ease;
}

.table tbody tr td {
  transition: background-color 0.3s ease;
}

.display-4 {
  font-family: 'Lato', sans-serif;
  font-size: 3rem;
  font-weight: 700;
  text-align: center;
  color: #333;
  margin-bottom: 1.5rem;
  text-transform: uppercase;
  letter-spacing: 2px;
  position: relative;
}

.display-4::after {
  content: '';
  width: 1500px;
  height: 4px;
  background-color: #ff7f00;
  display: block;
  margin: 10px auto 0;
}

h3 {
  font-size: 1.8rem;
  font-weight: bold;
}

.custom-btn {
  padding: 10px 20px;
  font-size: 16px;
  border: none;
  border-radius: 5px;
  cursor: pointer;
  background-color: #ff6600; /* Svetlija narandžasta boja */
  color: white;
  margin: 10px;
}

.custom-btn:hover {
  background-color: #ff3300; /* Tamnija narandžasta boja */
}

</style>
